<!--
     All Emoncms code is released under the GNU Affero General Public License.
     See COPYRIGHT.txt and LICENSE.txt.

        ---------------------------------------------------------------------
        Emoncms - open source energy visualisation
        Part of the OpenEnergyMonitor project:
        http://openenergymonitor.org
-->

<?php
    global $path, $embed;
?>

<!--[if IE]><script language="javascript" type="text/javascript" src="<?php echo $path;?>Lib/flot/excanvas.min.js"></script><![endif]-->
<script language="javascript" type="text/javascript" src="<?php echo $path;?>Lib/flot/jquery.flot.min.js"></script>
<script language="javascript" type="text/javascript" src="<?php echo $path;?>Lib/flot/jquery.flot.selection.min.js"></script>
<script language="javascript" type="text/javascript" src="<?php echo $path;?>Lib/flot/jquery.flot.stack.min.js"></script>
 <script language="javascript" type="text/javascript" src="<?php echo $path;?>Lib/flot/jquery.flot.time.min.js"></script>

<script language="javascript" type="text/javascript" src="<?php echo $path; ?>Modules/vis/visualisations/common/api.js"></script>
<script language="javascript" type="text/javascript" src="<?php echo $path; ?>Modules/vis/visualisations/common/inst.js"></script>

<?php if (!$embed) { ?>
<h2>Threshold</h2>
<?php } ?>

    <div id="graph_bound" style="height:400px; width:100%; position:relative; ">
        <div id="graph"></div>
        <h4 style="position:absolute; top:10px; left:75px; text-align:right;"><span id="stats"></span></h4>
        <div style="position:absolute; top:20px; right:20px;">

            <input class="time" type="button" value="D" time="1"/>
            <input class="time" type="button" value="W" time="7"/>
            <input class="time" type="button" value="M" time="30"/>
            <input class="time" type="button" value="Y" time="365"/> |

            <input id="zoomin" type="button" value="+"/>
            <input id="zoomout" type="button" value="-"/>
            <input id="left" type="button" value="<"/>
            <input id="right" type="button" value=">"/>

        </div>
    </div>

<script id="source" language="javascript" type="text/javascript">

    var embed = <?php echo $embed; ?>;

    $('#graph').width($('#graph_bound').width());
    $('#graph').height($('#graph_bound').height());
    if (embed) $('#graph').height($(window).height());

    var feedid = <?php echo $feedid; ?>;
    var thresholdA = <?php echo $thresholdA; ?>;
    var thresholdB = <?php echo $thresholdB; ?>;

    var path = "<?php echo $path; ?>";
    var apikey = "<?php echo $apikey; ?>";

    var timeWindow = (3600000*24.0*7);                //Initial time window
    var start = ((new Date()).getTime())-timeWindow;      //Get start time
    var end = (new Date()).getTime();             //Get end time

    var dataA = get_kwhatpower(feedid,0,thresholdA);
    var dataB = get_kwhatpower(feedid,thresholdA+1,thresholdB);
    var dataC = get_kwhatpower(feedid,thresholdB+1,20000);

    vis_feed_data();

    $(window).resize(function(){
        $('#graph').width($('#graph_bound').width());
        if (embed) $('#graph').height($(window).height());
        vis_feed_data();
    });

    function vis_feed_data()
    {

        $.plot($("#graph"), [{color: "#c1a81f", data:dataA}, {color: "#dec225", data:dataB}, {color: "#deb368", data:dataC}],
        {
            series: {
                stack: true,
                bars: { show: true,align: "center",barWidth: (3600*18*1000),fill: true }
            },
            grid: { show: true, hoverable: true, clickable: true },
            xaxis: { mode: "time", timezone: "browser", min: start, max: end, minTickSize: [1, "day"], tickLength: 1 },
            selection: { mode: "x" },
            legend: { position: "nw"}
        });
    }

    $("#graph").bind("plothover", function (event, pos, item) {
        //var mdate = new Date(item.datapoint[0]);
        if (item) {
            if (item.seriesIndex == 0) val = parseFloat(dataA[item.dataIndex][1]);
            if (item.seriesIndex == 1) val = parseFloat(dataB[item.dataIndex][1]);
            if (item.seriesIndex == 2) val = parseFloat(dataC[item.dataIndex][1]);
            $("#stats").html(val.toFixed(1));
        }
    });

    //--------------------------------------------------------------------------------------
    // Graph zooming
    //--------------------------------------------------------------------------------------
    $("#graph").bind("plotselected", function (event, ranges)
    {
         start = ranges.xaxis.from; end = ranges.xaxis.to;
         vis_feed_data();
    });

    //----------------------------------------------------------------------------------------------
    // Operate buttons
    //----------------------------------------------------------------------------------------------
    $("#zoomout").click(function () {inst_zoomout(); vis_feed_data();});
    $("#zoomin").click(function () {inst_zoomin(); vis_feed_data();});
    $('#right').click(function () {inst_panright(); vis_feed_data();});
    $('#left').click(function () {inst_panleft(); vis_feed_data();});
    $('.time').click(function () {inst_timewindow($(this).attr("time")); vis_feed_data();});
    //-----------------------------------------------------------------------------------------------
</script>

